/*
 * Axelor Business Solutions
 *
 * Copyright (C) 2019 Axelor (<http://axelor.com>).
 *
 * This program is free software: you can redistribute it and/or  modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.axelor.apps.suppliermanagement.web;

import com.axelor.apps.base.db.Partner;
import com.axelor.apps.base.db.repo.PartnerRepository;
import com.axelor.apps.purchase.db.PurchaseOrder;
import com.axelor.apps.purchase.db.PurchaseOrderLine;
import com.axelor.apps.purchase.db.repo.PurchaseOrderLineRepository;
import com.axelor.apps.purchase.db.repo.PurchaseOrderRepository;
import com.axelor.apps.suppliermanagement.exceptions.IExceptionMessage;
import com.axelor.apps.suppliermanagement.service.PurchaseOrderSupplierLineService;
import com.axelor.apps.suppliermanagement.service.PurchaseOrderSupplierService;
import com.axelor.db.mapper.Mapper;
import com.axelor.exception.service.TraceBackService;
import com.axelor.i18n.I18n;
import com.axelor.inject.Beans;
import com.axelor.rpc.ActionRequest;
import com.axelor.rpc.ActionResponse;
import com.google.inject.Singleton;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;

@Singleton
public class PurchaseOrderController {

  public void generateSuppliersPurchaseOrder(ActionRequest request, ActionResponse response) {

    PurchaseOrder purchaseOrder = request.getContext().asType(PurchaseOrder.class);
    List<PurchaseOrder> purchaseOrders =
        Beans.get(PurchaseOrderRepository.class)
            .all()
            .filter("self.parentPurchaseOrder = ?1 ", purchaseOrder.getId())
            .fetch();

    if (purchaseOrders.size() < 1) {
      try {
        Beans.get(PurchaseOrderSupplierService.class)
            .generateSuppliersPurchaseOrder(
                Beans.get(PurchaseOrderRepository.class).find(purchaseOrder.getId()));
        response.setFlash(I18n.get(IExceptionMessage.PURCHASE_ORDER_1));
        response.setReload(true);
      } catch (Exception e) {
        TraceBackService.trace(response, e);
      }
    } else {
      response.setFlash("Vous avez deja genere les commandes fournisseurs associees");
    }
  }

  public void generateSuppliersRequests(ActionRequest request, ActionResponse response) {

    PurchaseOrder purchaseOrder = request.getContext().asType(PurchaseOrder.class);

    try {
      Beans.get(PurchaseOrderSupplierService.class)
          .generateAllSuppliersRequests(
              Beans.get(PurchaseOrderRepository.class).find(purchaseOrder.getId()));
      response.setFlash(I18n.get(IExceptionMessage.PURCHASE_ORDER_2));
      response.setReload(true);
    } catch (Exception e) {
      TraceBackService.trace(response, e);
    }
  }

  // sophal
  @SuppressWarnings({"unchecked", "rawtypes"})
  public void setPurchaseOrderLinesPartner(ActionRequest request, ActionResponse response) {
    try {
      List<HashMap> selectedPurchaseOrderLineMapList =
          (List<HashMap>) request.getContext().get("purchaseOrderLineList");
      if (selectedPurchaseOrderLineMapList == null) {
        response.setFlash(I18n.get(IExceptionMessage.PURCHASE_ORDER_1));
        return;
      }

      List<PurchaseOrderLine> purchaseOrderLineList = new ArrayList<>();
      PurchaseOrderLineRepository purchaseOrderLineRepo =
          Beans.get(PurchaseOrderLineRepository.class);
      for (HashMap map : selectedPurchaseOrderLineMapList) {
        PurchaseOrderLine purchaseOrderLine =
            (PurchaseOrderLine) Mapper.toBean(PurchaseOrderLine.class, map);
        purchaseOrderLineList.add(purchaseOrderLineRepo.find(purchaseOrderLine.getId()));
      }

      if (purchaseOrderLineList.isEmpty()) {
        response.setFlash(I18n.get(IExceptionMessage.PURCHASE_ORDER_2));
        return;
      }

      Long partnerId = 0L;

      LinkedHashMap<String, Object> partnerHashMap =
          (LinkedHashMap<String, Object>) request.getContext().get("partner");
      if (partnerHashMap != null) {
        partnerId = Long.valueOf(partnerHashMap.get("id").toString());
      }
      Partner partner = Beans.get(PartnerRepository.class).find(partnerId);
      if (partner == null) {
        response.setFlash("No partners");
        return;
      }

      Beans.get(PurchaseOrderSupplierLineService.class)
          .setPurchaseOrderLinesPartner(purchaseOrderLineList, partner);
      response.setCanClose(true);
    } catch (Exception e) {
      TraceBackService.trace(response, e);
    }
  }
}
